variables:
  GITLAB_ACCESS_TOKEN: "OVERWRITTEN_BY_ENVIRONMENT"
  GITLAB_DOMAIN_SCHEME: "https"
  GITLAB_DOMAIN_TLD: "com"
  GITLAB_DOMAIN_PREFIX: "gitlab"
  GITLAB_VERIFIED_DOMAIN_TLD: "com"
  GITLAB_VERIFIED_DOMAIN_PREFIX: "emptyscope"
  GITLAB_GROUP_PREFIX: "emptyscope"
  GITLAB_TEMPLATE_PREFIX: "template"
  GITLAB_DOTFILES_LOCATION: "dotfiles"
  GITLAB_ARTIFACT_FOLDER_NAME: "init-setup"
  GITLAB_URL_PREFIX: "$GITLAB_DOMAIN_SCHEME://$GITLAB_DOMAIN_PREFIX.$GITLAB_DOMAIN_TLD"
  GITLAB_URL_GROUP_PREFIX: "$GITLAB_URL_PREFIX/$GITLAB_GROUP_PREFIX"
  DOCKER_TLS_DIR: "certs"
  DOCKER_IMAGE_URL: "$DOCKER_REGISTRY/$DOCKER_REGISTRY_USER/$PROJECT_NAME"
  TIMEOUT_SECONDS: 600

echo:
  stage: build
  extends: .echo_template
  only:
    - /^echo-.*$/

.echo_template:
  image: mcr.microsoft.com/dotnet/sdk:9.0.101-alpine3.20
  script:
    - echo 'Hello World'
  tags:
    - gitlab-org

.git_login_template:
  image: mcr.microsoft.com/dotnet/sdk:9.0.101-alpine3.20
  before_script:
    - apk add git
    - git config --global user.email "$GITLAB_EMAIL"
    - git config --global user.name "$GITLAB_USERNAME"
    - git remote set-url --push origin "$GITLAB_DOMAIN_SCHEME://$GITLAB_ACCESS_TOKEN_NAME:$GITLAB_ACCESS_TOKEN@$GITLAB_DOMAIN_PREFIX.$GITLAB_DOMAIN_TLD/$CI_PROJECT_PATH.git"
  tags:
    - gitlab-org

.git_build_template:
  image: mcr.microsoft.com/dotnet/sdk:9.0.101-alpine3.20
  before_script:
    - apk add bash
    - apk add curl
    - apk add sed
    - apk add git
    - mkdir $GITLAB_ARTIFACT_FOLDER_NAME
  artifacts:
    untracked: true
  tags:
    - gitlab-org

.git_deploy_template:
  extends: .git_login_template
  script:
    - export LAST_COMMIT_MESSAGE=$(git log -1 --pretty=%B)
    - cp -a $GITLAB_ARTIFACT_FOLDER_NAME/. .
    - rm -rf $GITLAB_ARTIFACT_FOLDER_NAME/
    - git add -A
    - git commit -m $LAST_COMMIT_MESSAGE
    - git push origin HEAD:$CI_COMMIT_REF_NAME -f
  tags:
    - gitlab-org

.glab_login_template:
  image:
    name: "gitlab/glab"
    entrypoint: [""]
  before_script:
    - glab auth login --hostname $GITLAB_URL_PREFIX --api-host $GITLAB_URL_PREFIX --api-protocol $GITLAB_DOMAIN_SCHEME --git-protocol ssh --job-token $CI_JOB_TOKEN
    # - glab auth login --hostname $GITLAB_URL_PREFIX --api-host $GITLAB_URL_PREFIX --api-protocol $GITLAB_DOMAIN_SCHEME --git-protocol ssh --token $GITLAB_ACCESS_TOKEN
    - glab --version
  tags:
    - gitlab-org

.docker_login_template:
  image: ${CI_DEPENDENCY_PROXY_DIRECT_GROUP_IMAGE_PREFIX}/docker:24.0.5
  services:
    - docker:24.0.5-dind
  variables:
    DOCKER_TLS_CERTDIR: "/$DOCKER_TLS_DIR"
  before_script:
    - apk add sed
    - export LOWERCASE_IMAGE_URL=$(echo "$DOCKER_IMAGE_URL" | sed -e 's/\(.*\)/\L\1/')
    - docker login -u $DOCKER_REGISTRY_USER -p "$DOCKER_REGISTRY_PASSWORD" $DOCKER_REGISTRY
  tags:
    - docker
    - gitlab-org

.docker_build_template:
  extends: .docker_login_template
  script:
    - docker build . --tag "$LOWERCASE_IMAGE_URL:$CI_COMMIT_REF_SLUG"
  tags:
    - docker
    - gitlab-org

.docker_release_template:
  extends: .docker_login_template
  script:
    - docker build . --tag "$LOWERCASE_IMAGE_URL:$CI_COMMIT_REF_SLUG"
    - docker tag "$LOWERCASE_IMAGE_URL:$CI_COMMIT_REF_SLUG" "$LOWERCASE_IMAGE_URL:$PROJECT_VERSION"
    - docker tag "$LOWERCASE_IMAGE_URL:$CI_COMMIT_REF_SLUG" "$LOWERCASE_IMAGE_URL:$latest"
    - docker push "$LOWERCASE_IMAGE_URL:$CI_COMMIT_REF_SLUG" --all-tags
  tags:
    - docker
    - gitlab-org

.docker_deploy_template:
  extends: .docker_login_template
  script:
    - docker build . --tag "$LOWERCASE_IMAGE_URL:$CI_COMMIT_REF_SLUG"
    - docker tag "$LOWERCASE_IMAGE_URL:$CI_COMMIT_REF_SLUG" "$LOWERCASE_IMAGE_URL:$PROJECT_VERSION"
    - docker tag "$LOWERCASE_IMAGE_URL:$CI_COMMIT_REF_SLUG" "$LOWERCASE_IMAGE_URL:$latest"
    - docker push "$LOWERCASE_IMAGE_URL:$CI_COMMIT_REF_SLUG" --all-tags
  tags:
    - docker
    - gitlab-org

.docker_run_template:
  extends: .docker_login_template
  script:
    - export LOWERCASE_IMAGE_URL=$(echo "$DOCKER_IMAGE_URL" | sed -e 's/\(.*\)/\L\1/')
    - docker run -p 5000:80 --env PROJECT_PREFIX=$PROJECT_PREFIX "$LOWERCASE_IMAGE_URL:$CI_COMMIT_REF_SLUG"
  tags:
    - docker
    - gitlab-org
